Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 956)
+++ lemon/lgf_writer.h	(revision 1270)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2013
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -192,18 +192,47 @@
     };
 
-    template <typename Value>
+    template <typename Value,
+              typename Map = std::map<Value, std::string> >
     struct MapLookUpConverter {
-      const std::map<Value, std::string>& _map;
-
-      MapLookUpConverter(const std::map<Value, std::string>& map)
+      const Map& _map;
+
+      MapLookUpConverter(const Map& map)
         : _map(map) {}
 
-      std::string operator()(const Value& str) {
-        typename std::map<Value, std::string>::const_iterator it =
-          _map.find(str);
+      std::string operator()(const Value& value) {
+        typename Map::const_iterator it = _map.find(value);
         if (it == _map.end()) {
           throw FormatError("Item not found");
         }
         return it->second;
+      }
+    };
+
+    template <typename Value,
+              typename Map1 = std::map<Value, std::string>,
+              typename Map2 = std::map<Value, std::string> >
+    struct DoubleMapLookUpConverter {
+      const Map1& _map1;
+      const Map2& _map2;
+
+      DoubleMapLookUpConverter(const Map1& map1, const Map2& map2)
+        : _map1(map1), _map2(map2) {}
+
+      std::string operator()(const Value& value) {
+        typename Map1::const_iterator it1 = _map1.find(value);
+        typename Map1::const_iterator it2 = _map2.find(value);
+        if (it1 == _map1.end()) {
+          if (it2 == _map2.end()) {
+            throw FormatError("Item not found");
+          } else {
+            return it2->second;
+          }
+        } else {
+          if (it2 == _map2.end()) {
+            return it1->second;
+          } else {
+            throw FormatError("Item is ambigous");
+          }
+        }
       }
     };
@@ -916,7 +945,8 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
+  /// \brief Return a \ref lemon::DigraphWriter "DigraphWriter" class
+  ///
+  /// This function just returns a \ref lemon::DigraphWriter
+  /// "DigraphWriter" class.
   ///
   /// With this function a digraph can be write to a file or output
@@ -939,7 +969,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref DigraphWriter
+  /// For a complete documentation, please see the
+  /// \ref lemon::DigraphWriter "DigraphWriter"
   /// class documentation.
-  /// \warning Don't forget to put the \ref DigraphWriter::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::DigraphWriter::run() "run()"
   /// to the end of the parameter list.
   /// \relates DigraphWriter
@@ -987,5 +1018,5 @@
   /// \ingroup lemon_io
   ///
-  /// \brief \ref lgf-format "LGF" writer for directed graphs
+  /// \brief \ref lgf-format "LGF" writer for undirected graphs
   ///
   /// This utility writes an \ref lgf-format "LGF" file.
@@ -1043,6 +1074,6 @@
     /// \brief Constructor
     ///
-    /// Construct a directed graph writer, which writes to the given
-    /// output stream.
+    /// Construct an undirected graph writer, which writes to the
+    /// given output stream.
     GraphWriter(const GR& graph, std::ostream& os = std::cout)
       : _os(&os), local_os(false), _graph(graph),
@@ -1051,5 +1082,5 @@
     /// \brief Constructor
     ///
-    /// Construct a directed graph writer, which writes to the given
+    /// Construct a undirected graph writer, which writes to the given
     /// output file.
     GraphWriter(const GR& graph, const std::string& fn)
@@ -1064,5 +1095,5 @@
     /// \brief Constructor
     ///
-    /// Construct a directed graph writer, which writes to the given
+    /// Construct a undirected graph writer, which writes to the given
     /// output file.
     GraphWriter(const GR& graph, const char* fn)
@@ -1290,7 +1321,7 @@
     }
 
-    /// \brief Add an additional caption to the \c \@arcs section
-    ///
-    /// Add an additional caption to the \c \@arcs section.
+    /// \brief Add an additional caption to the \c \@edges section
+    ///
+    /// Add an additional caption to the \c \@edges section.
     GraphWriter& edges(const std::string& caption) {
       _edges_caption = caption;
@@ -1555,7 +1586,7 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
+  /// \brief Return a \ref lemon::GraphWriter "GraphWriter" class
+  ///
+  /// This function just returns a \ref lemon::GraphWriter "GraphWriter" class.
   ///
   /// With this function a graph can be write to a file or output
@@ -1574,7 +1605,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref GraphWriter
+  /// For a complete documentation, please see the
+  /// \ref lemon::GraphWriter "GraphWriter"
   /// class documentation.
-  /// \warning Don't forget to put the \ref GraphWriter::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::GraphWriter::run() "run()"
   /// to the end of the parameter list.
   /// \relates GraphWriter
